/*
 * Epoch 4.0 - Structures for interval support.  Buttons will be anchored
 *	       by left edges of intervals, rather than by markers.  This
 *	       will be dramatically less expensive for updates upon
 *	       insertion/deletions in buffer; slightly more expensive when
 *	       getting button positions.
 *
 * This implementation of intervals is a simplified version of an intervals
 * prototype developed by Dan LaLiberte.
 *
 * $Revision: 1.1 $
 * $Source: /import/kaplan/stable/distrib/epoch-4.0b0/src/RCS/interval.h,v $
 * $Date: 91/11/21 12:45:55 $ 
 * $Author: love $
 */

struct Lisp_Interval
{
#if 0
  int size;
  struct Lisp_Vector *vec_next;
#endif
  int num;			/* Node numbering for debugging */
  int instances;		/* Number of markers at this node */
  int bump;			/* # of chars in this interval +
				 * left and right subtrees
				 */
#if 0  
  struct buffer *b;		/* buffer */
#endif  
  struct Lisp_Interval *parent;	/* parent node */
  struct Lisp_Interval *left;	/* left subtree */
  struct Lisp_Interval *right;	/* right subtree */
  struct Lisp_Interval *data;	/* data - subtree, or nil if at button */
};

#if 0
#define XINTERVAL(a) ((struct Lisp_Interval *)XPNTR(a))
#define INTERVALP(a) ( XTYPE(a) == Lisp_Interval)
#endif

struct Lisp_Interval *get_interval_node();
struct Lisp_Interval *find_interval();
struct Lisp_Interval *find_inner_interval_tree();
struct Lisp_Interval *split_interval_here();
struct Lisp_Interval *split_interval();
struct Lisp_Interval *splay_interval_left();
struct Lisp_Interval *splay_interval_right();
struct Lisp_Interval *delete_interval();
struct Lisp_Interval *balance_interval_tree();
struct Lisp_Interval *balance_interval();

  
